using System.Collections.Generic;
using Ato.CD.Inbound.Shared;
using Ato.EN.IntegrationServices.CodeGenerationRDTIS;

namespace Ato.CD.Inbound.Shared202002
{
    public static class RDTIS2020ContextsExtension
    {
        public static List<Context> GetContexts(this RDTIS2020 rdtis)
        {
            var contexts = new List<Context>();
            contexts.AddContext(rdtis.RPStartDate, rdtis.RPEndDate, rdtis.RPOccurrenceIndex).
                        AddContext(rdtis.RPCTAUSStartDate, rdtis.RPCTAUSEndDate, rdtis.RPCTAUSOccurrenceIndex).
                        AddContext(rdtis.RPCTFORStartDate, rdtis.RPCTFOREndDate, rdtis.RPCTFOROccurrenceIndex).
                        AddContext(rdtis.RPYPreviousStartDate, rdtis.RPYPreviousEndDate, rdtis.RPYPreviousOccurrenceIndex);

            if (rdtis.GMContextCollection != null)
            {
                foreach (var ChildGMContext in rdtis.GMContextCollection)
                {
                    contexts.AddContext(ChildGMContext.StartDate, ChildGMContext.EndDate, ChildGMContext.OccurrenceIndex);
                }
            }
            return contexts;
        }
    }
}
